<?php
/**
* Neat chat / Chat filter
*
* Provides parsing & custom look & filtering to chat
* Created by Reaby
*
*/
Aseco::registerEvent('onStartup',		'cChat_onStartup');
Aseco::registerEvent('onChat',			'cChat_chat');

function cChat_onStartup ($aseco, $command) 
{
	$aseco->client->query('ChatEnableManualRouting', true);  // do the trick to disable on game chat :)
	global $customChat;
	$customChat = new customChat();
		
}

class customChat {
public $player;
}

function cChat_chat($aseco, $command)
	{
	global $customChat;
	// Filter or not to filter -- Accepts: true / false
	$enableFilter = false;
	
	// list your bad words here
	$badwords = array ("fuck", "hell", "fck", "asshole", "homo", "anus", "penis", "motherfucker", "fucker", "vittu", "vitun", "saatana", "stana", "perkele", "prkl", "jumalauta");
	
	// and what to replace :)
	$badWordReplace = "%&%¤!";
	

	if ( $command[0] != $aseco->server->login)  // check if chat text is really from player, not from server.
		{
			$aseco->client->query('GetPlayerInfo', $command[1]);	 // get nickname instead of login...
			$info = $aseco->client->getResponse();     // 
			$nick = $info['NickName'];   // assign nickname from data. 
			$login = $command[1];
			$chat = $command[2];  // we want to process chat text later, so save it to temp variable
			$timestamp = date("H:i",time()); // timestamp
			if ($command != '' && substr($command[2], 0, 1) != '/' )  // check is command is ment to be server releated
			{
				
				if ($enableFilter == true) {
					foreach ($badwords as $words) // find badwords
					{
						$chat = str_ireplace($words,$badWordReplace,$chat); // and replace them with better word
					}
				} 
			
			// replace login names with nicknames on chat
			foreach ($aseco->server->players->player_list as $pl) {
					$chat = str_ireplace($pl->login,$pl->nickname."\$z\$s\$fff",$chat);
			}
			
		 //  this will compose the message to game, yellow text will be replaced with white here.
		 
		//$message =  "\$n" . $timestamp . "\$z\$s " . $nick . "  \$z\$s\$fff" . $chat;   // <-- uncomment this if you want to use timestamps
		$message =  "\$z\$s".$nick . "  \$z\$s\$fff" . $chat;                             // <-- uncomment this if you want white text
		//		$message =  "\$z\$s[ ".$nick ." \$z\$s] " . $chat;                        // <-- uncomment this if you want normal trackmania text
		
					$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));  // send chat to game
			}
			else 
			{
			$customChat->Player = $command[1];
			return; // return if command is server releated, else it will get executed twice.
			}
		
		} else   // and server messages are shown
		
		{
		
		$message = $command[2];
		$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $customChat->Player);
		
		}
			
}

?>